---
title: while
slug: Web/JavaScript/Reference/Statements/while
tags:
  - JavaScript
  - Language feature
  - Statement
  - while
---
<div>{{jsSidebar("Statements")}}</div>

<p>The <strong>while statement</strong> creates a loop that executes a specified statement as long as the test condition evaluates to true. The condition is evaluated before executing the statement.</p>

<div>{{EmbedInteractiveExample("pages/js/statement-while.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">while (<var>condition</var>)
  <var>statement</var>
</pre>

<dl>
 <dt><code><var>condition</var></code></dt>
 <dd>An expression evaluated before each pass through the loop. If this condition evaluates to true, <code><var>statement</var></code> is executed. When condition evaluates to false, execution continues with the statement after the <code>while</code> loop.</dd>
 <dt><code><var>statement</var></code></dt>
 <dd>An optional statement that is executed as long as the condition evaluates to true. To execute multiple statements within the loop, use a <a href="/en-US/docs/JavaScript/Reference/Statements/block">block</a> statement (<code>{ ... }</code>) to group those statements.<br>
 <br>
 Note: Use the <code>break</code> statement to stop a loop before condition evaluates to true.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_while">Using while</h3>

<p>The following <code>while</code> loop iterates as long as <code>n</code> is less than three.</p>

<pre class="brush:js">var n = 0;
var x = 0;

while (n &lt; 3) {
  n++;
  x += n;
}</pre>

<p>Each iteration, the loop increments <code>n</code> and adds it to <code>x</code>. Therefore, <code>x</code> and <code>n</code> take on the following values:</p>

<ul>
 <li>After the first pass: <code>n</code> = 1 and <code>x</code> = 1</li>
 <li>After the second pass: <code>n</code> = 2 and <code>x</code> = 3</li>
 <li>After the third pass: <code>n</code> = 3 and <code>x</code> = 6</li>
</ul>

<p>After completing the third pass, the condition <code>n</code> &lt; 3 is no longer true, so the loop terminates.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-while-statement', 'while statement')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.statements.while")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Statements/do...while", "do...while")}}</li>
 <li>{{jsxref("Statements/for", "for")}}</li>
</ul>
